#include <stdarg.h>

#include "doomtype.h"
#include "doomstat.h"
#include "d_player.h"
#include "s_sound.h"
#include "gi.h"
#include "d_net.h"
#include "g_game.h"
#include "p_local.h"
#include "sv_main.h"
#include "i_system.h"
#include "c_console.h"
#include "c_dispatch.h"
#include "m_argv.h"
#include "m_random.h"
#include "s_sndseq.h"
#include "v_video.h"

#include "i_net.h"

// ** SV_AUTHORITY.CPP **
//
// For many users and server admins, this is the juicy part
// Kicking people and banning them as well =)
//
// But hey, whos going to protect us from the ass holes?
//

struct ban_t
{
	int		active;
	char	*ip;
	char	*reason;
};


//#define		MAX_BANS		15

//ban_t		bans[MAX_BANS];
ban_t		*bans;
static		int		numbans=0;

void printblank(int	num, int max)
{
	int skip = max-num;
	int	i;
	

	for (i=0; i<skip; i++)
	{
		Printf(PRINT_HIGH, " ");
	}
}


BEGIN_COMMAND(players)
{
	player_t*	p;
	int	i;

	Printf(PRINT_HIGH, "\n *********** LIST ***********\n");
	Printf(PRINT_HIGH, "#   ADDRESS                        NAME\n");                 
	
	for (i=0; i<MAXPLAYERS; i++)
	{
		if (clients[i].cls < cs_spawned)
		{ continue; }

		p = &players[i];

		Printf(PRINT_HIGH, "%d", i);
		printblank(sizeof(i), 7);

		Printf(PRINT_HIGH, "%s", NET_AdrToString(clients[i].address));
		printblank(sizeof(NET_AdrToString(clients[i].address)), 20);

		Printf(PRINT_HIGH, "%s", p->userinfo.netname);
	
	}

	Printf(PRINT_HIGH, "\n ****************************\n");
}
END_COMMAND(players)


void SV_KickPlayer(int pnum, char *reason)
{

	player_t*	p = &players[pnum];

	SV_CheckBuffer(&clients[pnum], &clients[pnum].reliablebuf, sizeof(reason)+2);
	MSG_WriteByte(&clients[pnum].reliablebuf, svc_kick);
	MSG_WriteString(&clients[pnum].reliablebuf, reason);

	MSG_WriteByte(&clients[pnum].reliablebuf, svc_disconnect);

	SV_SendPacket(&clients[pnum]);

	playeringame[pnum] = false;
	clients[pnum].cls = cs_free;

	if (p->mo)
	{
		p->mo->Destroy();
		p->mo = NULL;
	}

	SV_BroadcastPrintf (PRINT_HIGH, "%s was kicked from the game\n", players[pnum].userinfo.netname);

	delete[] reason;
}



//
// COMMAND - kick Sends a simple message to the client to disconnect
//

BEGIN_COMMAND(kick)
{

	player_t	*p;
	char		*reason;
	int			pnum;

	if (argc < 3)
	{
		Printf (PRINT_HIGH, "\nKICK <player num> <reason>\n");
		Printf (PRINT_HIGH, "\n     Kicks a player off the server with a kick message\n\n");
		return;
	}

	pnum = atoi(argv[1]);
	p = &players[pnum];


	if (!playeringame[pnum])
	{
		Printf(PRINT_HIGH, "\n ** Player %d not found!\n", pnum);
		return;
	}

	reason = BuildString (argc - 2, argv + 2);

	SV_KickPlayer(pnum, reason);
	delete[] reason;
}
END_COMMAND(kick)


static BOOL SV_FindBan (const char *name, int *stoppos, int len)
{
	int i, cval = 1;

	for (i = 0; i < numbans; i++)
	{
		cval = strnicmp (bans[i].ip, name, len);
		if (cval >= 0)
			break;
	}

	*stoppos = i;

	return (cval == 0);
}

//
// SV_AddBan - Adds a ban to the ban list
//
void SV_AddBan(const char *ip,	const char	*reason)
{
	int		pos,i;

	if (SV_FindBan (ip, &pos, MAXINT))
	{
		
	}
	else
	{
		numbans++;
			
		bans = (ban_t *)Realloc (bans, sizeof(struct ban_t) * numbans);
		if (pos < numbans - 1)
			memmove (bans + pos + 1, bans + pos,
					 (numbans - pos - 1) * sizeof(struct ban_t));

		bans[pos].ip = copystring(ip);
		bans[pos].reason = copystring(reason);
		bans[pos].active = 10;

		Printf(PRINT_HIGH, "%s added to shitlist\n", bans[pos].ip);
		
	}

	for (i=0; i<MAXPLAYERS; i++)
	{
		if (clients[i].cls == cs_free)
			continue;

		SV_EnforceBans(&clients[i]);
	}
}


bool SV_RemoveBan(const char	*ip)
{
	int pos;

	if (SV_FindBan(ip, &pos, MAXINT))
	{
		numbans--;
		delete[] bans[pos].ip;
		if (pos < numbans)
			memmove (bans + pos, bans + pos + 1,
					 (numbans - pos) * sizeof(struct ban_t));
		return true;
	}

	return false;
}


//
// SV_ShowBanList - Displays every IP currently banned from the 
//					server.
//

void SV_ShowBanList(void)
{
	int		i;

	Printf(PRINT_HIGH, "\n *********** BANS ***********\n");

	for (i=0; i<numbans; i++)
	{
		//if (bans[i].active <= 0)
		//	continue;

		Printf(PRINT_HIGH, "%s\n", bans[i].ip);
	}

	Printf(PRINT_HIGH, "\n ****************************\n");
}




//
// SV_WriteBans - Saves all the bans currently into memory in a file
//
void SV_WriteBans(char	*filename)
{
	FILE	*openfile;
	int		i;

	openfile = fopen(filename, "w");

	if (!openfile)
	{
		Printf(PRINT_HIGH, "*** Unable to create ban log file!\n");
		return;
	}

	fprintf(openfile, "; \n");
	fprintf(openfile, "; ZDAEMON BAN FILE\n");
	fprintf(openfile, "; --------------------------\n");
	fprintf(openfile, ";Try not to hurt anything here.\n");
	fprintf(openfile, ";\n");

	for(i=0; i<numbans; i++)
	{
		if (!bans[i].ip)	// corrupted or something
			continue;

		if (!bans[i].reason)
		{ sprintf(bans[i].reason, " "); }

		fprintf(openfile, "%s#%s\n",bans[i].ip, bans[i].reason);
	}

	fclose(openfile);
}


//
// Makes a seperate string off of another string. (like cut/paste)
//

char	*cut_string(char	*string, int start, int max)
{

	char	newstring[1024];
	int	i;

	//memset (string, 0, sizeof(string));
	

	for (i=start; i<max; i++)
	{
		newstring[i-start] = string[i];

		if (!newstring[i+1])
			return (char *)newstring;
	}

	return (char *)newstring;
}



//
// SV_ReadBans - Reads & parses the ban list into memory
//

int SV_ReadBans(char	*filename)
{
	FILE	*openfile;
	char	parse[1024];
	char	*reason;
	int		num_bans=0;
	int		i;
	
	openfile = fopen (filename, "r");

	if (!openfile)
	{
		return 0;
	}


	while (fgets (parse, 1024, openfile) != NULL)
	{

		// These are comments
		if (parse[0] == ';')  { continue; }

		for (i=0; i<1024; i++)
		{
			// The # sign is used to distinguish between ips and reasons
			if (parse[i] == '#')
			{
				reason = cut_string(parse, i+1, 1024);
				parse[i] = '\0';
				break;
			}
		}

		SV_AddBan(parse, reason);
		num_bans++;
	}

	fclose(openfile);

	return num_bans;
}


bool checkbanmask(char	*ip, char *mask)
{
	int		i=0, ii=0;

	while (mask[i]) { i++; }


	//Printf(PRINT_HIGH, "no masks\n");
	// mask has no er...masks  =)
	//return false;

//next:

	if (i<=0 || (sizeof (ip) != sizeof (mask)))
		return false;
	
	ip[i] = '\0';

	if (!strcmp(ip, mask))
		return true;

	return false;

	
}







char	*convertjustip(char	*ip)
{
	int		i=0;
	//char	*newip;

	while (ip[i])
	{
		if (ip[i] == ':')
		{
			ip[i] = '\0';
			return ip;
		}

		i++;

	}

	return ip;
}


//
// SV_EnforceBans - Checks through all the IP's and checks to see
//					if who is on the server is banned. If so, cya!
//

int SV_EnforceBans(client_t*	cl)
{
	int		i;//, ii;
	char	*address;
	char	string[1024];
	int		retvalue=-10;

	for (i=0; i<numbans; i++)
	{
		if (cl->cls == cs_free)
			continue;
		
		address= convertjustip(NET_AdrToString(cl->address));
	
		if (!strcmp(address, bans[i].ip) || checkbanmask(address, bans[i].ip))
		{
		
			player_t	*p = &players[cl->count];

			sprintf(string, "BANNED: %s", bans[i].reason);

			SV_CheckBuffer(cl, &cl->reliablebuf, sizeof(string)+1);
			MSG_WriteByte(&cl->reliablebuf, svc_kick);
			MSG_WriteString(&cl->reliablebuf, string);
	
			if (cl->cls != cs_spawned)
				NET_SendPacket(cl->reliablebuf.cursize, cl->reliablebuf.data, cl->address);
			else
				SV_SendPacket(cl);
	
			playeringame[cl->count] = false;
			cl->cls = cs_free;
	
			if (p->mo)
			{
				p->mo->Destroy();
				p->mo = NULL;
				SV_BroadcastPrintf (PRINT_HIGH, 
				"%s banned\n", p->userinfo.netname);
			}
			else
			{
				Printf (PRINT_HIGH, 
					"%s is banned\n", NET_AdrToString(cl->address));
			}

			retvalue = 10;
		}
	}

	return retvalue;
}
	



BEGIN_COMMAND(banlist)
{
	SV_ShowBanList();
}
END_COMMAND(banlist)


BEGIN_COMMAND(addban)
{

	char	*reason;

	if (argc < 3)
	{
		Printf (PRINT_HIGH, "\nADDBAN <ip> <reason>\n");
		Printf (PRINT_HIGH, "\n     Bans an IP address from this server.\n\n");
		return;
	}

	reason = BuildString (argc - 2, argv + 2);

	SV_AddBan(argv[1],	reason);

	SV_WriteBans(BANFILE);
}
END_COMMAND(addban)


BEGIN_COMMAND(killban)
{
	if (argc < 2)
	{
		Printf(PRINT_HIGH, "\nKILLBAN <ip>\n");
		Printf(PRINT_HIGH, "\n      Removes a banned IP from the shit list.\n\n");
		return;
	}
	
	if (SV_RemoveBan(argv[1]))
	{
		Printf(PRINT_HIGH, "%s unbanned.\n", argv[1]);
		SV_WriteBans(BANFILE);
	}
	else
	{
		Printf(PRINT_HIGH, "unable to locate ban\n");
	}

	
}
END_COMMAND(killban)