#include "doomtype.h"
#include "doomstat.h"
#include "d_player.h"
#include "p_local.h"
#include "sv_main.h"
#include "c_console.h"

#define MASTERPORT 15100


netadr_t  masteraddr; // address of the master server
char      masterip[] = "zdaemon.ath.cx";
//char      masterip[] = "127.0.0.1";
buf_t     ml_message;
byte      ml_message_buffer[MAX_UDP_PACKET];

char      wadname[32];
char	  gamename[128];
char	  gameiwad[128];
bool      pwad;

CVAR (master, "1", CVAR_SERVERINFO);
CVAR (hostname, "Unnamed", CVAR_SERVERINFO);
CVAR (wadurl, "None set", CVAR_SERVERINFO);
CVAR (email, "None set", CVAR_SERVERINFO);

bool masterupdate;

//
// SV_InitMaster
//
void SV_InitMaster(void)
{
	NET_StringToAdr (masterip, &masteraddr);

	I_SetPort(masteraddr, MASTERPORT);

	ml_message.data = ml_message_buffer;
	ml_message.maxsize = sizeof(ml_message_buffer);
}


//
// SV_UpdateMaster
//
void SV_UpdateMaster(void)
{
	if (!master.value)
		return;

	// update masteraddr every 15 minutes
	if ((gametic % (TICRATE*60*15) ) == 0)
	{
		NET_StringToAdr (masterip, &masteraddr);
		I_SetPort(masteraddr, MASTERPORT);
	}

	if ((gametic % (TICRATE*25)) && !masterupdate)
		return;

	masterupdate = false;

	SZ_Clear(&ml_message);
	MSG_WriteLong(&ml_message, CHALLENGE);
	MSG_WriteByte(&ml_message, VERSION);
	NET_SendPacket(ml_message.cursize, ml_message.data, masteraddr);
}

//
// SV_SendServerInfo
// Sends server info to a launcher
//
void SV_SendServerInfo()
{
	int numclients = 0;
	int numplayers = 0;
	int num_wads = 0;
	int	gametype = 0;
	int i;

	for (i=0; i<MAXPLAYERS; i++)
		if (clients[i].cls >= cs_connected)
			numclients++;

	SZ_Clear(&ml_message);
	MSG_WriteLong(&ml_message, CHALLENGE);

	MSG_WriteString(&ml_message, (char *)hostname.string);

	MSG_WriteByte(&ml_message, numclients);
	MSG_WriteByte(&ml_message, maxclients);

	MSG_WriteString(&ml_message, level.mapname);
	
	// First count how many wads there are
	for (i=0; i<4; i++)
	{ if (strlen(server_wads[i]) > 0) { num_wads++; } }

	MSG_WriteByte(&ml_message, num_wads);

	for (i=0; i<4; i++)
	{ 
		if (strlen(server_wads[i]) > 0)
		{ MSG_WriteString(&ml_message, server_wads[i]);  }
	}

	if (deathmatch.value)
	{ gametype = 0; }		// Deathmatch (FFA)
	else if (teamplay.value)
	{ gametype = 1; }		// Teamplay deathmatch
	else	// Coop. games
	{ gametype = 2; }

	//MSG_WriteByte(&ml_message, (byte)deathmatch.value);
	
	MSG_WriteByte(&ml_message, gametype);
	MSG_WriteString(&ml_message, gamename);
	MSG_WriteString(&ml_message, gameiwad);
	MSG_WriteByte(&ml_message, (byte)gameskill.value);
	MSG_WriteString(&ml_message, (char *)wadurl.string);
	MSG_WriteString(&ml_message, (char *)email.string);

	MSG_WriteLong(&ml_message, dmflags);
	
	for (i=0; i<MAXPLAYERS; i++)
		if (clients[i].cls == cs_spawned)
			numplayers++;

	MSG_WriteByte(&ml_message, numplayers);
			
	for (i=0; i<MAXPLAYERS; i++)
	{
		if (clients[i].cls != cs_spawned)
			continue;

		MSG_WriteString(&ml_message, players[i].userinfo.netname);
		if (teamplay.value || deathmatch.value)
			MSG_WriteShort(&ml_message, players[i].fragcount);
		else
			MSG_WriteShort(&ml_message, players[i].killcount);
		MSG_WriteShort(&ml_message, int(players[i].ping / 35.0 * 1000) );
	}

	// [NF] - Now send the version num
	MSG_WriteShort(&ml_message, VERSION);

	NET_SendPacket(ml_message.cursize, ml_message.data, net_from);
}
