#include <stdarg.h>

#include "doomtype.h"
#include "doomstat.h"
#include "d_player.h"
#include "s_sound.h"
#include "gi.h"
#include "d_net.h"
#include "g_game.h"
#include "p_local.h"
#include "sv_main.h"
#include "i_system.h"
#include "c_console.h"
#include "c_dispatch.h"
#include "m_argv.h"
#include "m_random.h"
#include "s_sndseq.h"
#include "v_video.h"
#include "w_wad.h"

#include "i_net.h"



BEGIN_COMMAND(showstats)
{
	Printf(PRINT_HIGH, "MAP: %s\n", level.mapname);
	
	for (int i=0; i<MAXPLAYERS; i++)
	{
		if (!playeringame[i])
			continue;

		Printf(PRINT_HIGH, "%s with ( %d ) frags\n", &players[i].userinfo.netname,
			players[i].frags);
	}
}
END_COMMAND(showstats)



//
// SV_SaveStats - Saves stats to a binary file 'sv_stats.sav'
//

void	SV_SaveStats(void)
{
	FILE	*savefile;
	//int		i, num=0;
    
	savefile = fopen("sv_stats.sav", "wb");

    if (!savefile) 
	{   Printf(PRINT_HIGH, "***Unable to create stat file!\n");
		return; 
	}

    // write all player info
	fwrite(level.mapname, sizeof(char), 8, savefile);
	fclose(savefile);

	//Printf(PRINT_HIGH, "*** Recorded %d player records\n", num+1);
}


//
// SV_LoadStats - Loads the map stats back into memory 
//

int SV_LoadStats(void)
{
	
	FILE	*openfile;
	char	use_map[8];

    openfile = fopen("sv_stats.sav", "rb");

    if (!openfile) { return -10; }

    // read from primary layer
	fread(use_map, sizeof(char), 8, openfile);

	if (!use_map || !use_map[0])
	{   Printf(PRINT_HIGH, "*** no stat data found\n");
		return -10;
	}

	if (W_CheckNumForName (use_map) == -1)
	{ //Printf (PRINT_HIGH, "No map %s\n", use_map);
	  return -10;
	}
	else
	{
		Printf(PRINT_HIGH, "*** Using backed up map: %s\n", use_map);
		SV_ExitLevel();
		G_DeferedInitNew (use_map);
	}

	fclose(openfile);
	return 10;
}


void SV_ClearStats(void)
{
	FILE	*savefile;
    
	savefile = fopen("sv_stats.sav", "w");

	fclose(savefile);
}




