#include "gZDLaunch.h"
#include "searchdoomer.xpm"
#include "launch.xpm"
#include "exit.xpm"
#include "prefs.xpm"
#include "refresh.xpm"
#include "zdaemon.xpm"

void GUI(void)
{
	GtkWidget *maintable;
	GtkWidget *vpaned;
	GtkWidget *hpaned;
	GtkWidget *playerlist;
	GtkWidget *scroll;
	GtkWidget *menubar;
	GtkWidget *handlebox;
	GtkWidget *zdaemonicon;
	GtkWidget *notebook;

	char *servertitles[7] =
	    { "Name", "IP-Adress", "Players", "Ping", "Map", "WAD",
		"Game"
	};
	char *playertitles[3] = { "Ping", "Frags", "Name" };
	char *rulestitles[2] = { "Type", "Value" };
	char *flagstitles[2] = { "State", "Flags" };
	char *pwadtitles[1] = { "PWAD" };

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_default_size(GTK_WINDOW(window), 800, 600);
	gtk_window_set_title(GTK_WINDOW(window), "GNOME ZDaemon Launcher");

	maintable = gtk_table_new(2, 4, FALSE);

	vpaned = gtk_vpaned_new();
	hpaned = gtk_hpaned_new();

	serverlist = gtk_clist_new_with_titles(7, servertitles);
	playerlist = gtk_clist_new_with_titles(3, playertitles);
	ruleslist = gtk_clist_new_with_titles(2, rulestitles);
	allplayerlist = gtk_clist_new_with_titles(3, playertitles);
	dmflagslist = gtk_clist_new_with_titles(2, flagstitles);
	pwadlist = gtk_clist_new_with_titles(1, pwadtitles);
	
	gtk_widget_show(window);

	notebook = gtk_notebook_new();

//      handlebox = gtk_handle_box_new();
//      gtk_handle_box_set_shadow_type(GTK_HANDLE_BOX(handlebox),
//                                     GTK_SHADOW_NONE);

	handlebox = gtk_handle_box_new();
//      gtk_handle_box_set_shadow_type(GTK_HANDLE_BOX(handlebox),
//                                     GTK_SHADOW_NONE);
	gtk_container_add(GTK_CONTAINER(handlebox),
			  getToolBar(window, serverlist));
	gtk_table_attach(GTK_TABLE(maintable), handlebox, 0, 1, 1, 2,
			 GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);

	zdaemonicon = CreateWidgetFromXpm(window, (char **) zdaemon_xpm);

	get_main_menu(window, &menubar);

	handlebox = gtk_handle_box_new();
	gtk_container_add(GTK_CONTAINER(handlebox), menubar);
	gtk_table_attach(GTK_TABLE(maintable), handlebox, 0, 1, 0, 1,
			 GTK_FILL | GTK_EXPAND, GTK_FILL, 0, 0);

	gtk_table_attach(GTK_TABLE(maintable), zdaemonicon, 1, 2, 0, 2,
			 GTK_FILL, GTK_FILL, 2, 0);
	scroll = gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll),
				       GTK_POLICY_AUTOMATIC,
				       GTK_POLICY_AUTOMATIC);
	gtk_container_add(GTK_CONTAINER(scroll), serverlist);
	gtk_paned_pack1(GTK_PANED(vpaned), scroll, FALSE, TRUE);
	gtk_paned_set_position(GTK_PANED(vpaned), 245);

	scroll = gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll),
				       GTK_POLICY_AUTOMATIC,
				       GTK_POLICY_AUTOMATIC);
	gtk_container_add(GTK_CONTAINER(scroll), playerlist);
	gtk_paned_pack2(GTK_PANED(vpaned), hpaned, TRUE, TRUE);
	gtk_paned_pack1(GTK_PANED(hpaned), scroll, TRUE, TRUE);

	scroll = gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll),
				       GTK_POLICY_AUTOMATIC,
				       GTK_POLICY_AUTOMATIC);
	gtk_container_add(GTK_CONTAINER(scroll), ruleslist);
	gtk_paned_pack2(GTK_PANED(hpaned), scroll, TRUE, TRUE);

	gtk_clist_set_column_width(GTK_CLIST(serverlist), 0, 300);
	gtk_clist_set_column_width(GTK_CLIST(serverlist), 1, 133);
	gtk_clist_set_column_width(GTK_CLIST(serverlist), 2, 40);
	gtk_clist_set_column_width(GTK_CLIST(serverlist), 3, 38);
	gtk_clist_set_column_width(GTK_CLIST(serverlist), 4, 45);
	gtk_clist_set_column_width(GTK_CLIST(serverlist), 5, 100);
	gtk_clist_set_column_width(GTK_CLIST(playerlist), 0, 38);
	gtk_clist_set_column_width(GTK_CLIST(allplayerlist), 0, 38);
	gtk_clist_set_column_width(GTK_CLIST(ruleslist), 0, 100);
	gtk_clist_set_auto_sort(GTK_CLIST(serverlist), TRUE);
	gtk_clist_set_sort_column(GTK_CLIST(serverlist), 3);


	gtk_notebook_set_tab_pos(GTK_NOTEBOOK(notebook), GTK_POS_TOP);
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), vpaned,
				 gtk_label_new("Servers"));
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), allplayerlist,
				 gtk_label_new("All Players"));
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), dmflagslist,
				 gtk_label_new("DMFlags"));
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook), pwadlist,
				 gtk_label_new("PWADs"));

	gtk_table_attach(GTK_TABLE(maintable), notebook, 0, 2, 2, 3,
			 GTK_FILL | GTK_EXPAND, GTK_FILL | GTK_EXPAND, 2,
			 2);
	gtk_table_attach(GTK_TABLE(maintable), InitConsole(), 0, 2, 3, 4,
			 GTK_FILL, GTK_FILL, 2, 2);

	ParseConfig();

	gtk_container_add(GTK_CONTAINER(window), maintable);

	gtk_signal_connect_object(GTK_OBJECT(window), "destroy",
				  GTK_SIGNAL_FUNC(app_main_quit), NULL);
	gtk_signal_connect_object(GTK_OBJECT(window), "delete_event",
				  GTK_SIGNAL_FUNC(app_main_quit), NULL);
	gtk_signal_connect_object(GTK_OBJECT(serverlist), "select_row",
				  GTK_SIGNAL_FUNC(DisplayPlayerInfo),
				  GTK_OBJECT(playerlist));
	gtk_signal_connect_object(GTK_OBJECT(serverlist), "unselect_row",
				  GTK_SIGNAL_FUNC(Unselect), NULL);

	gtk_signal_connect_object(GTK_OBJECT(allplayerlist), "select_row",
				  GTK_SIGNAL_FUNC(ShowPlayerServer), NULL);
	gtk_widget_show_all(window);
}

void ShowPlayerServer(GtkWidget * widget, int row)
{
	char *playername;
	GtkWidget *tmpentry;

	tmpentry = gtk_entry_new();
	gtk_clist_get_text(GTK_CLIST(allplayerlist), row, COL_PLAYERNAME,
			   &playername);
	delchar(playername, '\t');
	delchar(playername, '\n');
	gtk_entry_set_text(GTK_ENTRY(tmpentry), playername);
	FindDoomer(tmpentry);
}

void get_main_menu(GtkWidget * window, GtkWidget ** menubar)
{
	static GtkItemFactoryEntry menu_items[] = {
		{"/_Action", NULL, NULL, 0, "<Branch>"},
		{"/Action/_Launch", "<alt>L", GTK_SIGNAL_FUNC(LaunchGame),
		 0, NULL},
		{"/Action/_Refresh", "<alt>R",
		 GTK_SIGNAL_FUNC(GetMasterList), 0, NULL},
		{"/Action/_Find doomer ...", "<alt>F",
		 GTK_SIGNAL_FUNC(FindDoomerDialog), 0, NULL},
		{"/Action/_Exit", "<alt>X", GTK_SIGNAL_FUNC(app_main_quit),
		 0, NULL},
		{"/_Options", NULL, NULL, 0, "<Branch>"},
		{"/Options/_Preferences ...", "<alt>P",
		 GTK_SIGNAL_FUNC(ConfigDialog), 0, NULL},
	};

	GtkItemFactory *item_factory;
	GtkAccelGroup *accel_group;
	gint nmenu_items = 7;

	accel_group = gtk_accel_group_new();
	item_factory =
	    gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>", accel_group);
	gtk_item_factory_create_items(item_factory, nmenu_items,
				      menu_items, NULL);
	gtk_accel_group_attach(accel_group, GTK_OBJECT(window));
	if (menubar)
		*menubar =
		    gtk_item_factory_get_widget(item_factory, "<main>");
}

GtkWidget *CreateWidgetFromXpm(GtkWidget * window, gchar ** xpm_data)
{
	GdkBitmap *mask;
	GdkPixmap *pixmap_data;
	GtkWidget *pixmap_widget;

	pixmap_data = gdk_pixmap_create_from_xpm_d(window->window,
						   &mask,
						   NULL,
						   (gchar **) xpm_data);
	pixmap_widget = gtk_pixmap_new(pixmap_data, mask);
	gtk_widget_show(pixmap_widget);

	return pixmap_widget;
}

GtkWidget *getToolBar(GtkWidget * window, GtkWidget * serverlist)
{
	GtkWidget *refr_item;
	GtkWidget *toolbar;

	toolbar =
	    gtk_toolbar_new(GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
	gtk_container_set_border_width(GTK_CONTAINER(toolbar), 2);
	gtk_toolbar_set_space_style(GTK_TOOLBAR(toolbar),
				    GTK_TOOLBAR_SPACE_LINE);
	gtk_toolbar_set_button_relief(GTK_TOOLBAR(toolbar),
				      GTK_RELIEF_NONE);

	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar), "Launch",
				"Launch a game", NULL,
				CreateWidgetFromXpm(window,
						    (char **) launch_xpm),
				LaunchGame, NULL);
	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar), "Exit", "Exit", NULL,
				CreateWidgetFromXpm(window,
						    (char **) exit_xpm),
				app_main_quit, NULL);
	gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));
	refr_item =
	    gtk_toolbar_append_item(GTK_TOOLBAR(toolbar), "Refresh",
				    "Refresh server list", NULL,
				    CreateWidgetFromXpm(window,
							(char **)
							refresh_xpm), NULL,
				    NULL);
	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar), "Find Doomer",
				"Search for a Doom player on all servers",
				NULL, CreateWidgetFromXpm(window,
							  (char **)
							  searchdoomer_xpm),
				FindDoomerDialog, NULL);
	gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));
	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar), "Preferences",
				"Set Preferences", NULL,
				CreateWidgetFromXpm(window,
						    (char **) prefs_xpm),
				ConfigDialog, NULL);
	gtk_signal_connect_object(GTK_OBJECT(refr_item), "clicked",
				  GTK_SIGNAL_FUNC(GetMasterList), NULL);
	return (toolbar);
}

void FindDoomerDialog(void)
{
	GtkWidget *dialog;
	GtkWidget *widget;
	GtkWidget *table;
	GtkWidget *search_player_entry;
	dialog = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_window_set_title(GTK_WINDOW(dialog), "Search Doomer");
	table = gtk_table_new(2, 2, TRUE);
	gtk_container_add(GTK_CONTAINER(dialog), table);
	gtk_container_set_border_width(GTK_CONTAINER(dialog), 10);
	PrintConsole
	    ("Please enter the name of a doom player to the dialog box and press OK\n",
	     "normal");

	widget = gtk_button_new_with_label("Cancel");
	gtk_table_attach_defaults(GTK_TABLE(table), widget, 1, 2, 1, 2);
	gtk_signal_connect_object(GTK_OBJECT(widget), "clicked",
				  GTK_SIGNAL_FUNC(gtk_widget_destroy),
				  GTK_OBJECT(dialog));
	widget = gtk_button_new_with_label("Search");
	search_player_entry = gtk_entry_new();

	gtk_table_attach_defaults(GTK_TABLE(table), widget, 0, 1, 1, 2);
	gtk_signal_connect_object(GTK_OBJECT(widget), "clicked",
				  GTK_SIGNAL_FUNC(FindDoomer),
				  GTK_OBJECT(search_player_entry));
	gtk_signal_connect_object(GTK_OBJECT(widget), "clicked",
				  GTK_SIGNAL_FUNC(gtk_widget_destroy),
				  GTK_OBJECT(dialog));

	gtk_table_attach_defaults(GTK_TABLE(table), search_player_entry, 0,
				  2, 0, 1);

	gtk_widget_show_all(dialog);
}

void app_main_quit(void)
{
	remove(playerfile);
	remove(infofile);
	remove("/tmp/zdaemon.log");
	save_config();
	exit(EXIT_SUCCESS);
}

void Unselect(void)
{
	nowrow = -1;
}
