#       include <sys/types.h>
#       include <sys/socket.h>
#       include <netinet/in.h>
#       include <arpa/inet.h>
#       include <errno.h>
#       include <unistd.h>
#       include <netdb.h>
#       include <sys/ioctl.h>
#       include <sys/time.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include <ctype.h>
#include <math.h>
#include "i_net.h"
#include "returnval.h"

void slashswitch(char *string);

int I_GetTime(void)
{
	struct timeval tv;
	struct timezone tz;
	long tm;
	gettimeofday(&tv, &tz);
	tm = tv.tv_sec * 1000 + tv.tv_usec / 1000;
	return tm;
}

int main(int argc, char *argv[])
{
	int tmp;
	int i;
	int beforetime;
	int aftertime;
	char mapname[255];
	char wadname[255];
	char playername[255];
	char adminmail[255];
	char downloadurl[255];
	int playerping;
	int playerfrags;
	int gzdl_call=0;
	int num_pwads=0;
	
	if(argc<2)
	{
		printf("Usage: %s serverip:port\n",argv[0]);
		exit(EXIT_FAILURE);
	}
	else if(argc==3)
	{
		if(!strcmp(argv[2],"--gzdl"))  gzdl_call=1;
	}

	netadr_t server_adress;
	buf_t message;
	byte message_buffer[MAX_UDP_PACKET];

	message.data = message_buffer;
	message.maxsize = sizeof(message_buffer);

	InitNetCommon();

	NET_StringToAdr (argv[1], &server_adress);
	SZ_Clear(&message);
	MSG_WriteLong(&message, LAUNCHER_CHALLENGE);
	NET_SendPacket(message.cursize, message.data, server_adress);
	beforetime=I_GetTime();
	I_DoSelect();

	if(NET_GetPacket())
	{
	aftertime=I_GetTime();
		if(gzdl_call!=0)
		{
			printf("%s\n",argv[1]);
			fprintf(stderr,"%s\n",argv[1]);
		}

		if (MSG_ReadLong() != CHALLENGE)
		{
			printf("Can't connect to %s\n",argv[1]);
			if(gzdl_call!=0)
			{  
				fprintf(stderr,"Can't connect to %s\n",argv[1]);
				printf("------next------\n");
				fprintf(stderr,"------next------\n");
			}
			return(RET_NOCONNECT);
		}
	
		if(gzdl_call==0)  printf("Server name: ");

		printf("%s\n", MSG_ReadString());

		tmp=MSG_ReadByte();
		if(gzdl_call==0)  printf("Players: ");
		
		printf("%i/%i\n", tmp, MSG_ReadByte());

		strcpy(mapname,MSG_ReadString());


		num_pwads = MSG_ReadByte();
		if(gzdl_call==1)  printf("%i\n",num_pwads);
		if (num_pwads > 0)
		{
			//strcpy(wadname,MSG_ReadString());
			if(gzdl_call==0) 
			{
				printf("Map %s of ",mapname);
				for (int i=0; i<num_pwads; i++) // check to see if the server is running a pwad
				{
					printf("%s ",MSG_ReadString());       // read the server pwad name
				}
					
				printf("is playing at the moment\n");
			}
			else
			{
				for (int i=0; i<num_pwads; i++) // check to see if the server is running a pwad
				{
					printf("%s\n",MSG_ReadString());       // read the server pwad name
				}
				printf("%s\n",mapname);
			}
		}
		else
		{
			if(gzdl_call==0)  printf("Map %s is playing at the moment\n",mapname);
			else printf("%s\n",mapname);
		}

		tmp=MSG_ReadByte();
	
		if(gzdl_call==0)
		{
			printf("Game type: ");
			if(tmp==0)  printf("deathmatch\n");
			else if(tmp==1)  printf("teamplay\n");
			else if(tmp==2)  printf("Cooperative\n");
		}
		else
		{
			printf("%i\n",tmp);
		}

		if(gzdl_call==0)  printf("Game: %s",MSG_ReadString());
		else MSG_ReadString();
		
		if(gzdl_call==0)  printf(", IWAD: ");
		printf("%s\n",MSG_ReadString());

	if(gzdl_call==0)  printf("Skill: ");
	printf("%i\n",MSG_ReadByte()+1);

		sprintf(downloadurl,"%s",MSG_ReadString());
		slashswitch(downloadurl);
		if(gzdl_call==0)  printf("PWAD Download URL: "); printf("%s\n", downloadurl);
		if(gzdl_call==0)  printf("Admin's email: "); printf("%s\n", MSG_ReadString());
		if(gzdl_call==0)  printf("DMFlags: "); printf("%i\n", MSG_ReadLong());
		
		
		if(gzdl_call==0)  printf("Ping: "); printf("%i\n",aftertime-beforetime);
		
		tmp=MSG_ReadByte();
		if(gzdl_call==0)  { printf("Players:\n"); printf("Name\t\tFrags\tPing\n"); }

		if(tmp>0)
		{
		for (i=0; i<tmp; i++)
	        {
			strcpy(playername,MSG_ReadString());
			playerping=MSG_ReadShort();
			playerfrags=MSG_ReadShort();

			if(gzdl_call==0)  printf("%s\t%i\t%i\n",playername, playerping, playerfrags);
			else  fprintf(stderr,"%i\t::\t%i\t::\t%s\n",playerping,playerfrags,playername);
		}
		}
		if(gzdl_call==1)  { printf("%i\n",MSG_ReadShort()); }
		if(gzdl_call!=0)  { fprintf(stderr,"------next------\n"); printf("------next------\n"); }
		return(RET_NOERR);
	}
	else
	{
		printf("Can't connect to %s\n",argv[1]);
		if(gzdl_call!=0)
		{
			fprintf(stderr,"Can't connect to %s\n",argv[1]);
			printf("------next------\n");
			fprintf(stderr,"------next------\n");
		}
		return(RET_NOCONNECT);
	}
}

void slashswitch(char *string)
{
	char tempstr[strlen(string)];
	int tempint;
	int tempint2 = 0;

	for (tempint = 0; tempint <= strlen(string); tempint++)
	{
		if(string[tempint]=='\\')  tempstr[tempint]='/';
		else  tempstr[tempint]=string[tempint];
	}
	strcpy(string, tempstr);
}
