#include "gZDLaunch.h"
#include "ZLinuxTools/returnval.h"

int main(int argc, char *argv[])
{
#ifdef USE_GNOME
	gnome_init("ZDaemon Launcher", VERSION, argc, argv);
#else
	gtk_init(&argc, &argv);
#endif
	didrefresh = 0;
	nowrow = -1;
	notify_row = 0;
	opened_config = 0;
	GUI();

	gtk_main();
	return (0);
}

GtkWidget *InitConsole(void)
{
	GtkWidget *scroll;
	GtkWidget *table;
	char tmp[255];

	table = gtk_table_new(2, 1, FALSE);
	console = gtk_text_new(NULL, NULL);
	gtk_text_set_editable(GTK_TEXT(console), FALSE);
	gtk_text_set_word_wrap(GTK_TEXT(console), TRUE);
	gtk_text_set_line_wrap(GTK_TEXT(console), TRUE);
	scroll = gtk_vscrollbar_new(GTK_TEXT(console)->vadj);
	gtk_table_attach(GTK_TABLE(table), console, 0, 1, 0, 1,
			 GTK_FILL | GTK_EXPAND, GTK_FILL, 2, 2);
	gtk_table_attach(GTK_TABLE(table), scroll, 1, 2, 0, 1, GTK_FILL,
			 GTK_FILL, 2, 2);

	sprintf(tmp, "GNOME ZDaemon Launcher Console %s initialized ...\n",
		VERSION);
	PrintConsole(tmp, "normal");
	PrintConsole("GNOME ZDaemon Launcher GUI initialized ...\n",
		     "normal");

	return table;
}

void PrintConsole(char *text, char *type)
{
	GdkColor color;
	GdkColormap *cmap;
	char tmp[1024];

	cmap = gdk_colormap_get_system();

	if (!strcmp(type, "error"))
	{
		color.red = 0xffff;
		color.green = 0;
		color.blue = 0;
		gdk_color_alloc(cmap, &color);
		sprintf(tmp, "ERROR: %s", text);
		gtk_text_insert(GTK_TEXT(console), NULL, &color, NULL, tmp,
				-1);
	}
	else if (!strcmp(type, "extern"))
	{
		color.red = 0;
		color.green = 0;
		color.blue = 0x9999;
		gdk_color_alloc(cmap, &color);
		sprintf(tmp, "External: %s", text);
		gtk_text_insert(GTK_TEXT(console), NULL, &color, NULL, tmp,
				-1);
	}
	else if (!strcmp(type, "notify"))
	{
		color.red = 0;
		color.green = 0x9999;
		color.blue = 0;
		gdk_color_alloc(cmap, &color);
		sprintf(tmp, "Notify: %s", text);
		gtk_text_insert(GTK_TEXT(console), NULL, &color, NULL, tmp,
				-1);

	}
	else if (!strcmp(type, "normal"))
	{
		gtk_text_insert(GTK_TEXT(console), NULL, NULL, NULL, text,
				-1);

	}

}

void delchar(char *string, char dchar)
{
	char tempstr[strlen(string)];
	int tempint;
	int tempint2 = 0;

	for (tempint = 0; tempint <= strlen(string); tempint++)
	{
		if (string[tempint] != dchar)
		{
			tempstr[tempint2] = string[tempint];
			tempint2++;
		}
	}
	strcpy(string, tempstr);
}

int ExistFile(char *name)
{
	FILE *stream;

	stream = fopen(name, "r");

	if (!stream)
		return (RET_NOTEXISTS);
	else
		return (RET_EXISTS);
}

void CheckPlayerNotify(void)
{
	char filename[255];
	char tmp[16];
	FILE *notifydb;
	GtkWidget *entry;

	PrintConsole("Checking notify list ...\n", "normal");

	sprintf(filename, "%s/.gzdl-notify", getenv("HOME"));
	entry = gtk_entry_new();

	notifydb = fopen(filename, "r");

	if (!notifydb)
	{
		PrintConsole
		    ("No user notify list found. will create one\n",
		     "error");

		notifydb = fopen(filename, "w");
		if (!notifydb)
			return;

		fprintf(notifydb, "slayer[nfc]\n");
		fprintf(notifydb, "RvB\n\n");
		fclose(notifydb);

		notifydb = fopen(filename, "r");


	}

	fgets(tmp, 16, notifydb);
	do
	{
		delchar(tmp, '\n');
		delchar(tmp, '\t');
		if (strlen(tmp) < 1)
			return;
		gtk_entry_set_text(GTK_ENTRY(entry), tmp);
		FindDoomer(entry);
		fgets(tmp, 16, notifydb);
	}
	while (!feof(notifydb));
}

void LaunchGame(void)
{
	char *ip;
	char *wad;
	char fullwad[255];
	char *map;
	char *game;
	char tmp[255];
	char iwad[62];
	char cmdline[255];
	int ret;
	int i = 0;
	char *singlewad;
	
	if (nowrow == -1)
	{
		PrintConsole("you have to select a server first\n",
			     "error");
		return;
	}

	gtk_clist_get_text(GTK_CLIST(serverlist), nowrow, COL_SERVERIP,
			   &ip);
	gtk_clist_get_text(GTK_CLIST(serverlist), nowrow, COL_WAD, &wad);
	gtk_clist_get_text(GTK_CLIST(serverlist), nowrow, COL_MAP, &map);

	gtk_clist_get_text(GTK_CLIST(serverlist), nowrow, COL_GAME, &game);
	delchar(game, '\n');
	delchar(game, ' ');
	if (!strcasecmp(game, "doom2.wad"))
		sprintf(iwad, "%s", Config.Files.Iwad2);
	else if ((!strcasecmp(game, "doom.wad"))
		 || (!strcasecmp(game, "doom1.wad")))
		sprintf(iwad, "%s", Config.Files.Iwad1);
	else if (!strcasecmp(game, "hexen.wad"))
		sprintf(iwad, "%s", Config.Files.Iwadhx);
	else if (!strcasecmp(game, "heretic.wad"))
		sprintf(iwad, "%s", Config.Files.Iwadhc);
	else if (!strcasecmp(game, "tnt.wad"))
		sprintf(iwad, "%s", Config.Files.Iwadt);
	else if (!strcasecmp(game, "plutonia.wad"))
		sprintf(iwad, "%s", Config.Files.Iwadp);

	delchar(wad, '\n');
	strcpy(fullwad,"");
	ret = gtk_clist_get_text(GTK_CLIST(pwadlist), i, 0, &singlewad);
	while(ret)
	{
		i++;
		delchar(singlewad,'\n');
		sprintf(tmp, "%s/%s ", Config.Files.WadDir, singlewad);
		strcat(fullwad, tmp);
		ret = gtk_clist_get_text(GTK_CLIST(pwadlist), i, 0, &singlewad);
	}
	
	sprintf(cmdline,
		"%s -connect %s -file %s -iwad %s > /tmp/zdaemon.log 2>> /tmp/zdaemon.log\n",
		Config.Files.doomcl, ip, fullwad, iwad);
	system(cmdline);
	LoadLogsToConsole();
}

void LoadLogsToConsole(void)
{
	FILE *logfile;
	char logline[255];

	logfile = fopen("/tmp/zdaemon.log", "r");

	if (!logfile)
	{
		PrintConsole("Could not open zdaemon's logfile\n",
			     "error");
		return;
	}

	fgets(logline, 255, logfile);

	if (!feof(logfile))
	{
		do
		{
			PrintConsole(logline, "extern");

			fgets(logline, 255, logfile);
		}
		while (!feof(logfile));
	}
	fclose(logfile);

}
