#include <stdio.h>

#ifdef USE_GNOME
#include <gnome.h>
#else
#include <gtk/gtk.h>
#endif

#include <stdlib.h>
#include <string.h>

#define VERSION "0.99"
#define SERVERVERS 99

#define COL_SERVERNAME 0
#define COL_SERVERIP 1
#define COL_PLAYERS 2
#define COL_PING 3
#define COL_MAP 4
#define COL_WAD 5
#define COL_GAME 6

#define COL_PLAYERPING 0
#define COL_FRAGS 1
#define COL_PLAYERNAME 2

#define COL_RULE 0
#define COL_VALUE 1

#define WADDIR "/usr/local/share/zdoom/"
#define ZDAEMON "/usr/local/bin/zdaemon"
#define IWAD1 "/usr/local/share/zdoom/doom.wad"
#define IWAD2 "/usr/local/share/zdoom/doom2.wad"
#define IWADHX "/usr/local/share/zdoom/hexen.wad"
#define IWADHC "/usr/local/share/zdoom/heretic.wad"
#define IWADP "/usr/local/share/zdoom/plutonia.wad"
#define IWADT "/usr/local/share/zdoom/tnt.wad"

#define	DF_NO_HEALTH		1		// Do not spawn health items (DM)
#define	DF_NO_ITEMS			2		// Do not spawn powerups (DM)
#define	DF_WEAPONS_STAY		4		// Leave weapons around after pickup (DM)
#define	DF_YES_FALLING		8		// Falling too far hurts
#define DF_NO_FRIENDLY_FIRE	16		// Can't hurt teammates
#define	DF_SAME_LEVEL		64		// Stay on the same map when someone exits (DM)
#define	DF_SPAWN_FARTHEST	128		// Spawn players as far as possible from other players (DM)
#define DF_FORCE_RESPAWN	256		// Automatically respawn dead players after respawn_time is up (DM)
#define DF_NO_ARMOR			512		// Do not spawn armor (DM)
#define DF_NO_EXIT			1024	// Kill anyone who tries to exit the level (DM)
#define DF_INFINITE_AMMO	2048	// Don't use up ammo when firing
#define DF_NO_MONSTERS		4096	// Don't spawn monsters (replaces -nomonsters parm)
#define DF_MONSTERS_RESPAWN	8192	// Monsters respawn sometime after their death (replaces -respawn parm)
#define DF_ITEMS_RESPAWN	16384	// Items other than invuln. and invis. respawn
#define DF_FAST_MONSTERS	32768	// Monsters are fast (replaces -fast parm)
#define DF_NO_JUMP			65536	// Don't allow jumping
#define DF_NO_FREELOOK		131072	// Don't allow freelook
#define DF_RESPAWN_SUPER	262144	// Respawn invulnerability and invisibility


GtkWidget *serverlist;
GtkWidget *ruleslist;
GtkWidget *notifylist;
GtkWidget *allplayerlist;
GtkWidget *dmflagslist;
GtkWidget *pwadlist;
GtkWidget *window;
GtkWidget *console;
GtkWidget *doomclentry;
GtkWidget *iwad1entry;
GtkWidget *iwad2entry;
GtkWidget *iwadtentry;
GtkWidget *iwadpentry;
GtkWidget *iwadhxentry;
GtkWidget *iwadhcentry;
GtkWidget *waddirentry;

char playerfile[255];
char infofile[255];
int didrefresh;
int nowrow;
int notify_row;
int opened_config;

struct Configuration
{
	struct files 
	{
		char WadDir[255];
		char doomcl[255];
		char Iwad1[255];
		char Iwad2[255];
		char Iwadhc[255];
		char Iwadhx[255];
		char Iwadp[255];
		char Iwadt[255];
	}
	Files;
}
Config;

struct configline
{
        char *keyword;
        char *value;
        char wholeline[255];
};

typedef struct configline CFGLine;


int main(int, char**);
void GUI(void);
void get_main_menu(GtkWidget *, GtkWidget **);
GtkWidget *CreateWidgetFromXpm(GtkWidget *, gchar **);
GtkWidget *getToolBar(GtkWidget*,GtkWidget*);
void GetMasterList(void);
void Cannot(GtkWidget*, char*);
void GetPlayerInfo(GtkWidget*);
void app_main_quit(void);
void DisplayPlayerInfo(GtkWidget*,int);
void FindDoomerDialog(void);
GtkWidget* InitConsole(void);
void PrintConsole(char *, char *);
void FindDoomer(GtkWidget*);
void delchar(char*, char);
void CheckConfig(void);
int ExistFile(char*);
void CheckPlayerNotify(void);
void LaunchGame(void);
void ParseConfig(void);
void configure(char *keyword, char *value);
void save_config(void);
void ConfigDialog(void);
void ReadNotifyToConfigDialog(GtkWidget*);
void Unselect(void);
void SelectNotify(GtkWidget*,int,int);
void DeleteNotifyEntry(void);
void AddNotifyDialog(void);
void AddNotify(GtkWidget*);
void ApplyChanges(void);
void SaveNotify(void);
void LoadLogsToConsole(void);
void CloseConfig(void);
void InsertInfos(void);
void DisplayAllPlayerInfo();
void ShowPlayerServer(GtkWidget*, int);
void DecodeDMFlags(long int);
