#include "gZDLaunch.h"

void GetMasterList(void)
{
	char *serverrow[7];
	char tmp[1024];
	char filename[255];
	char vorlage[64];
	char cmdline[512];
	char title[128];
	FILE *masterfile;
	int retval;
	int i;
	int servercount = 0;
	PrintConsole("Getting server list ...\n", "normal");
	gtk_clist_clear(GTK_CLIST(serverlist));

	strcpy(vorlage, "/tmp/gzdl-XXXXXX");
	strcpy(filename, mktemp(vorlage));

	sprintf(cmdline, "/usr/local/bin/zspy --gzdl > %s", filename);
	retval = system(cmdline);
	if (retval != 0)
	{
		PrintConsole
		    ("GetMasterList: Can't connect to master server\n",
		     "error");
		remove(filename);

		return;
	}

	masterfile = fopen(filename, "r");

	if (!masterfile)
	{
		PrintConsole
		    ("GetMasterList: Can't read master server results\n",
		     "error");
		remove(filename);

		return;
	}

	for (i = 0; i <= 5; i++)
		serverrow[i] = malloc(sizeof(char) * 255);

	if (feof(masterfile))
	{
		PrintConsole
		    ("GetMasterList: Can't connect to master server\n",
		     "error");
		remove(filename);

		return;
	}
	else
	{
		while (!feof(masterfile))
		{
			serverrow[COL_SERVERNAME] = "";
			serverrow[COL_PLAYERS] = "";
			serverrow[COL_PING] = "";
			serverrow[COL_MAP] = "";
			serverrow[COL_WAD] = "";
			serverrow[COL_GAME] = "";
			fgets(serverrow[COL_SERVERIP], 255, masterfile);
			if (feof(masterfile))
				break;
			if(!strncmp(serverrow[COL_SERVERIP],"newver",6))
			{
				fgets(serverrow[COL_SERVERIP], 255, masterfile);
				sprintf(tmp,"A new ZDaemon Version is out, you can get it at %s\n",serverrow[COL_SERVERIP]);
			        PrintConsole(tmp,"error");
				return;
			}
			gtk_clist_append(GTK_CLIST(serverlist), serverrow);
			servercount++;
		}
	}
	fclose(masterfile);
	remove(filename);
	sprintf(title, "GNOME ZDaemon Launcher - Got %i servers\n",
		servercount);
	PrintConsole(title, "normal");
	gtk_window_set_title(GTK_WINDOW(window), title);
	GetPlayerInfo(serverlist);
}

void GetPlayerInfo(GtkWidget * serverlist)
{
	char *ip;
	char cmdline[255];
	char vorlage[64];
	char vorlage2[64];
	int i = 0;
	int ret;

	PrintConsole("Getting player informations ...\n", "normal");
	strcpy(vorlage, "/tmp/gzdl-player-XXXXXX");
	strcpy(vorlage2, "/tmp/gzdl-infos-XXXXXX");

	if (didrefresh == 0)
	{
		strcpy(playerfile, mktemp(vorlage));
		strcpy(infofile, mktemp(vorlage2));
	}
	else
	{
		remove(playerfile);
		remove(infofile);
	}

	didrefresh = 1;

	sprintf(cmdline, "cat /dev/null > %s", playerfile);
	system(cmdline);
	sprintf(cmdline, "cat /dev/null > %s", infofile);
	system(cmdline);

	ret =
	    gtk_clist_get_text(GTK_CLIST(serverlist), i, COL_SERVERIP,
			       &ip);
	while (ret)
	{
		ip[strlen(ip) - 1] = '\0';
		sprintf(cmdline,
			"/usr/local/bin/zinfo %s --gzdl 2>> %s >> %s", ip,
			playerfile, infofile);

		system(cmdline);
		i++;
		ret =
		    gtk_clist_get_text(GTK_CLIST(serverlist), i,
				       COL_SERVERIP, &ip);

	}
	InsertInfos();
	CheckPlayerNotify();
	DisplayAllPlayerInfo();
}

void DisplayAllPlayerInfo()
{
	char *playerrow[3];
	char playerline[255];
	FILE *playerptr;

	playerptr = fopen(playerfile, "r");
	gtk_clist_clear(GTK_CLIST(allplayerlist));

	fgets(playerline, 255, playerptr);

	if (feof(playerptr) || (!playerptr))
	{
		PrintConsole("Can't open player database", "error");
	}
	else
	{
		while (!feof(playerptr))
		{
			delchar(playerline, '\n');
			fgets(playerline, 255, playerptr);
			if (strcmp(playerline, "------next------\n"))
			{
				playerrow[COL_FRAGS] =
				    strtok(playerline, "::");
				playerrow[COL_PLAYERPING] =
				    strtok(NULL, "::");
				playerrow[COL_PLAYERNAME] =
				    strtok(NULL, "::");
				if (!strncmp
				    ("Can't", playerrow[COL_PLAYERPING],
				     5))
				{
					char *foo;
					char bar[255];
					delchar(foo, '\n');
					sprintf(bar,
						"Can't connect to %s for getting player infos\n",
						foo);
					PrintConsole(bar, "error");
					return;
				}
				gtk_clist_append(GTK_CLIST(allplayerlist),
						 playerrow);
			}
			else
			{
				fgets(playerline, 255, playerptr);
			}
		}
	}

}

void DecodeDMFlags(long int dmflags)
{
	char *dfrow[2];

	gtk_clist_clear(GTK_CLIST(dmflagslist));
	dfrow[1] = "Spawn health items";
	if (DF_NO_HEALTH & dmflags)
		dfrow[0] = "No";
	else
		dfrow[0] = "Yes";
	gtk_clist_append(GTK_CLIST(dmflagslist), dfrow);

	dfrow[1] = "Spawn powerups";
	if (DF_NO_ITEMS & dmflags)
		dfrow[0] = "No";
	else
		dfrow[0] = "Yes";
	gtk_clist_append(GTK_CLIST(dmflagslist), dfrow);

	dfrow[1] = "Weapons stay";
	if (DF_WEAPONS_STAY & dmflags)
		dfrow[0] = "Yes";
	else
		dfrow[0] = "No";
	gtk_clist_append(GTK_CLIST(dmflagslist), dfrow);

	dfrow[1] = "Falling damage";
	if (DF_YES_FALLING & dmflags)
		dfrow[0] = "Yes";
	else
		dfrow[0] = "No";
	gtk_clist_append(GTK_CLIST(dmflagslist), dfrow);

	dfrow[1] = "Friendly fire (Coop+Teamplay)";
	if (DF_NO_FRIENDLY_FIRE & dmflags)
		dfrow[0] = "Yes";
	else
		dfrow[0] = "No";
	gtk_clist_append(GTK_CLIST(dmflagslist), dfrow);

	dfrow[1] = "Stay on the same map when someone exits";
	if (DF_SAME_LEVEL & dmflags)
		dfrow[0] = "Yes";
	else
		dfrow[0] = "No";
	gtk_clist_append(GTK_CLIST(dmflagslist), dfrow);

	dfrow[1] = "Spawn players as far as possible from other players";
	if (DF_SPAWN_FARTHEST & dmflags)
		dfrow[0] = "Yes";
	else
		dfrow[0] = "No";
	gtk_clist_append(GTK_CLIST(dmflagslist), dfrow);

	dfrow[1] = "Automatically respawn dead players";
	if (DF_FORCE_RESPAWN & dmflags)
		dfrow[0] = "Yes";
	else
		dfrow[0] = "No";
	gtk_clist_append(GTK_CLIST(dmflagslist), dfrow);

	dfrow[1] = "Spawn armor";
	if (DF_NO_ARMOR & dmflags)
		dfrow[0] = "No";
	else
		dfrow[0] = "Yes";
	gtk_clist_append(GTK_CLIST(dmflagslist), dfrow);

	dfrow[1] = "Kill people who try to exit";
	if (DF_NO_EXIT & dmflags)
		dfrow[0] = "Yes";
	else
		dfrow[0] = "No";
	gtk_clist_append(GTK_CLIST(dmflagslist), dfrow);

	dfrow[1] = "Infinite ammo";
	if (DF_INFINITE_AMMO & dmflags)
		dfrow[0] = "Yes";
	else
		dfrow[0] = "No";
	gtk_clist_append(GTK_CLIST(dmflagslist), dfrow);

	dfrow[1] = "Monsters in game";
	if (DF_NO_MONSTERS & dmflags)
		dfrow[0] = "No";
	else
		dfrow[0] = "Yes";
	gtk_clist_append(GTK_CLIST(dmflagslist), dfrow);

	dfrow[1] = "Monsters respawn";
	if (DF_MONSTERS_RESPAWN & dmflags)
		dfrow[0] = "Yes";
	else
		dfrow[0] = "No";
	gtk_clist_append(GTK_CLIST(dmflagslist), dfrow);

	dfrow[1] = "Monsters are fast";
	if (DF_FAST_MONSTERS & dmflags)
		dfrow[0] = "Yes";
	else
		dfrow[0] = "No";
	gtk_clist_append(GTK_CLIST(dmflagslist), dfrow);

	dfrow[1] =
	    "Items other than invulnerability and invisibility respawn";
	if (DF_ITEMS_RESPAWN & dmflags)
		dfrow[0] = "Yes";
	else
		dfrow[0] = "No";
	gtk_clist_append(GTK_CLIST(dmflagslist), dfrow);

	dfrow[1] = "Jump";
	if (DF_NO_JUMP & dmflags)
		dfrow[0] = "No";
	else
		dfrow[0] = "Yes";
	gtk_clist_append(GTK_CLIST(dmflagslist), dfrow);

	dfrow[1] = "Free look";
	if (DF_NO_FREELOOK & dmflags)
		dfrow[0] = "No";
	else
		dfrow[0] = "Yes";
	gtk_clist_append(GTK_CLIST(dmflagslist), dfrow);

	dfrow[1] = "Respawn invulnerability and invisibility";
	if (DF_RESPAWN_SUPER & dmflags)
		dfrow[0] = "Yes";
	else
		dfrow[0] = "No";
	gtk_clist_append(GTK_CLIST(dmflagslist), dfrow);
}

void DisplayPlayerInfo(GtkWidget * playerlist, int row)
{
	char *playerrow[3];
	char *inforow[2];
	char playerline[255];
	char infoline[255];
	char *tmp;
	char tmp2[255];
	char tmp3[255];
	char numwads[255];
	int num_pwads;
	char *ip;
	char gametype[255];
	char skill[255];
	char url[255];
	char mail[255];
	char dmflags[255];
	FILE *playerptr;
	FILE *infoptr;
	int numplayers;
	char *pwadline[1];
	int j;
	int i;

	nowrow = row;

	gtk_clist_get_text(GTK_CLIST(serverlist), row, COL_SERVERIP, &ip);
	infoptr = fopen(infofile, "r");
	gtk_clist_clear(GTK_CLIST(ruleslist));
	gtk_clist_clear(GTK_CLIST(pwadlist));

	if (feof(infoptr) || (!infoptr))
	{
		PrintConsole("Can't open info database", "error");
	}
	else
	{
		while (!feof(infoptr))
		{
			fgets(infoline, 255, infoptr);
			delchar(infoline, '\n');
			delchar(ip, '\n');
			if (!strcmp(ip, infoline))
			{
				fgets(tmp3, 255, infoptr);
				fgets(tmp3, 255, infoptr);
				fgets(numwads, 255, infoptr);
				num_pwads=atoi(numwads);
				if(num_pwads>0)
				{
					for(i=0;i<num_pwads;i++)
					{
						fgets(tmp3, 255, infoptr);
						pwadline[0] = tmp3;
						gtk_clist_append(GTK_CLIST(pwadlist),pwadline);
					}
							
				}
				fgets(tmp3, 255, infoptr);
				fgets(gametype, 255, infoptr);
				inforow[COL_RULE] = "Game type";
				if (atoi(gametype) == 0)
					inforow[COL_VALUE] = "Deathmatch";
				else if (atoi(gametype) == 1)
					inforow[COL_VALUE] = "Teamplay";
				else if (atoi(gametype) == 2)
					inforow[COL_VALUE] = "Cooperative";
				gtk_clist_append(GTK_CLIST(ruleslist),
						 inforow);
				fgets(tmp3, 255, infoptr);	
				fgets(skill, 255, infoptr);
				inforow[COL_RULE] = "Skill";
				inforow[COL_VALUE] = skill;
				gtk_clist_append(GTK_CLIST(ruleslist),
						 inforow);
				fgets(url, 255, infoptr);
				inforow[COL_RULE] = "PWAD download";
				inforow[COL_VALUE] = url;
				gtk_clist_append(GTK_CLIST(ruleslist),
						 inforow);
				fgets(mail, 255, infoptr);
				inforow[COL_RULE] = "Admin email";
				inforow[COL_VALUE] = mail;
				gtk_clist_append(GTK_CLIST(ruleslist),
						 inforow);
				fgets(dmflags, 255, infoptr);
				inforow[COL_RULE] = "Freelook";
				if (!(atoi(dmflags) & 131072))
				{
					inforow[COL_VALUE] = "Yes";
				}
				else
				{
					inforow[COL_VALUE] = "No";
				}
				gtk_clist_append(GTK_CLIST(ruleslist),
						 inforow);

				inforow[COL_RULE] = "Jump";
				if (!(atoi(dmflags) & 65536))
				{
					inforow[COL_VALUE] = "Yes";
				}
				else
				{
					inforow[COL_VALUE] = "No";
				}
				gtk_clist_append(GTK_CLIST(ruleslist),
						 inforow);
				
				fgets(tmp3,255,infoptr);
				fgets(tmp3,255,infoptr);
				if(atoi(tmp3)!=SERVERVERS)
				{
					PrintConsole("Server version not compatible\n", "error");
				}
				DecodeDMFlags(atol(dmflags));

				fclose(infoptr);
				break;
			}
		}
	}

	playerptr = fopen(playerfile, "r");
	gtk_clist_clear(GTK_CLIST(playerlist));

	if (feof(playerptr) || (!playerptr))
	{
		PrintConsole("Can't open player database", "error");
	}
	else
	{
		while (!feof(playerptr))
		{
			fgets(playerline, 255, playerptr);
			delchar(playerline, '\n');
			delchar(ip, '\n');
			if (!strcmp(ip, playerline))
			{
				gtk_clist_get_text(GTK_CLIST(serverlist),
						   row, COL_PLAYERS, &tmp);
				strcpy(tmp2, tmp);
				numplayers = atoi(strtok(tmp2, "/"));
				if (numplayers == 0)
					break;
				for (j = 0; j < numplayers; j++)
				{
					fgets(playerline, 255, playerptr);
					if (strcmp
					    (playerline,
					     "------next------\n"))
					{
						playerrow[COL_FRAGS] =
						    strtok(playerline,
							   "::");
						playerrow[COL_PLAYERPING] =
						    strtok(NULL, "::");
						playerrow[COL_PLAYERNAME] =
						    strtok(NULL, "::");
						if (!strncmp
						    ("Can't",
						     playerrow
						     [COL_PLAYERPING], 5))
						{
							char *foo;
							char bar[255];

							gtk_clist_get_text
							    (GTK_CLIST
							     (serverlist),
							     row,
							     COL_SERVERNAME,
							     &foo);
							delchar(foo, '\n');
							sprintf(bar,
								"Can't connect to %s for getting player infos\n",
								foo);
							PrintConsole(bar,
								     "error");
							return;
						}
						gtk_clist_append(GTK_CLIST
								 (playerlist),
								 playerrow);
					}
				}
				break;
			}
		}
	}

}

void InsertInfos(void)
{
	char infoline[255];
	char *serverrow[7];
	char servername[255];
	char players[255];
	char serverip[255];
	char map[255];
	char wad[255];
	char game[255];
	char ping[255];
	int num_pwads;
	char numwads[255];
	FILE *infoptr;
	int i = 0;

	if (didrefresh == 0)
	{
		PrintConsole
		    ("there are no server informations available. please press the \"Refresh\" button in the toolbar\n",
		     "error");
		return;
	}
	strcpy(wad,"");
	infoptr = fopen(infofile, "r");

	gtk_clist_clear(GTK_CLIST(serverlist));
	if (feof(infoptr) || (!infoptr))
	{
		PrintConsole("Can't open info database\n", "error");
		return;
	}
	else
	{

		while (!feof(infoptr))
		{

			fgets(serverip, 255, infoptr);
			serverrow[COL_SERVERIP] = serverip;
			if (!strncmp(serverip, "Can't", 5))
			{
				fgets(infoline, 255, infoptr);
				continue;
			}

			fgets(servername, 255, infoptr);
			serverrow[COL_SERVERNAME] = servername;
			fgets(players, 255, infoptr);
			serverrow[COL_PLAYERS] = players;
	

			fgets(numwads, 255, infoptr);
			num_pwads = atoi(numwads);
			if(num_pwads>0)
			{
			for (i=0; i<num_pwads; i++) // check to see if the server is running a pwad
			{
				fgets(wad, 255, infoptr);

			}
			}
			fgets(map, 255, infoptr);
			serverrow[COL_MAP] = map;
			if(num_pwads>0) serverrow[COL_WAD] = wad;
			else serverrow[COL_WAD] = "";
			fgets(infoline, 255, infoptr);
			fgets(game, 255, infoptr);
			serverrow[COL_GAME] = game;
			fgets(infoline, 255, infoptr);
			fgets(infoline, 255, infoptr);
			fgets(infoline, 255, infoptr);
			fgets(infoline, 255, infoptr);
			fgets(ping, 255, infoptr);
			fgets(infoline, 255, infoptr);

			//if(atoi(infoline) == 092
			
			fgets(infoline, 255, infoptr);
			
			if (feof(infoptr))
				break;
			serverrow[COL_PING] = ping;

			gtk_clist_append(GTK_CLIST(serverlist), serverrow);

			i++;
		}
	}
}

void FindDoomer(GtkWidget * playername)
{
	char playerline[255];
	char tmp[255];
	char *tmp2;
	char foo[255];
	char *servername;
	char serverip[255];
	char *ip;
	int i = 0;
	int ret;
	FILE *playerptr;

	if (didrefresh == 0)
	{
		PrintConsole
		    ("there are no player informations available. please press the \"Refresh\" button in the toolbar\n",
		     "error");
		return;
	}

	playerptr = fopen(playerfile, "r");

	if (feof(playerptr) || (!playerptr))
	{
		PrintConsole("Can't open player database\n", "error");
		return;
	}
	else
	{
		fgets(serverip, 255, playerptr);
		while (!feof(playerptr))
		{
			if (!gtk_clist_get_text
			    (GTK_CLIST(serverlist), 0, COL_SERVERNAME,
			     &servername))
			{
				PrintConsole("No servers in serverlist\n",
					     "error");
				return;

			}
			fgets(playerline, 255, playerptr);
			if (!strncmp("------", playerline, 6))
			{
				fgets(serverip, 255, playerptr);
			}
			else if (strncmp("Can't", playerline, 4))

			{
				tmp2 = strtok(playerline, "::");
				tmp2 = strtok(NULL, "::");
				tmp2 = strtok(NULL, "::");
				tmp2[strlen(tmp2) - 1] = '\0';
				strcpy(foo, tmp2);
				delchar(foo, '\t');

				if (!strcasecmp
				    (gtk_entry_get_text
				     (GTK_ENTRY(playername)), foo))
				{
					ret =
					    gtk_clist_get_text(GTK_CLIST
							       (serverlist),
							       i,
							       COL_SERVERIP,
							       &ip);
					while (ret)
					{
						delchar(ip, '\n');
						delchar(serverip, '\n');
						if (!strcmp(ip, serverip))
						{
							gtk_clist_get_text
							    (GTK_CLIST
							     (serverlist),
							     i,
							     COL_SERVERNAME,
							     &servername);
							delchar(servername,
								'\n');
						}
						i++;
						ret =
						    gtk_clist_get_text
						    (GTK_CLIST(serverlist),
						     i, COL_SERVERIP, &ip);

					}


					sprintf(tmp,
						"%s online at %s (%s)\n",
						gtk_entry_get_text
						(GTK_ENTRY(playername)),
						servername, serverip);
					PrintConsole(tmp, "notify");
					return;
				}

			}
		}
	}
}
